import React from 'react';
import { EditorState, EditorStateConfig, Extension } from '@codemirror/state';
import { EditorView, ViewUpdate } from '@codemirror/view';
export interface ReactCodeMirrorRef {
    editor?: HTMLDivElement | null;
    state?: EditorState;
    view?: EditorView;
}
export interface ReactCodeMirrorProps extends Omit<EditorStateConfig, 'doc' | 'extensions'>, Omit<React.HTMLAttributes<HTMLDivElement>, 'onChange' | 'placeholder'> {
    height?: string;
    minHeight?: string;
    maxHeight?: string;
    width?: string;
    minWidth?: string;
    maxWidth?: string;
    value?: string;
    theme?: 'light' | 'dark';
    autoFocus?: boolean;
    editable?: boolean;
    extensions?: Extension[];
    root?: ShadowRoot | Document;
    onChange?(value: string, viewUpdate: ViewUpdate): void;
    onUpdate?(viewUpdate: ViewUpdate): void;
}
export interface UseCodeMirror extends ReactCodeMirrorProps {
    container?: HTMLDivElement | null;
}
